#ifndef ZASM_LINK_GLOBAL_H
#define ZASM_LINK_GLOBAL_H 1

#define LINK_GLOBAL_T(O) ((struct link_global_t *)(O))
struct link_global_t
{
  struct link_entry_t *global;
  struct link_expr_t *expr;
  struct link_global_t *next;
};

#include <zasm/alloc.h>
#define LINK_GLOBAL_ALLOC(O) ((struct link_global_alloc_t *)(O))
ALLOC_DECLARE(link_global, ALLOC_DEF_COUNT);

#include <zasm/link_namespace.h>
struct link_global_t *link_global_new(struct link_level_t *level, struct link_entry_t *g_entry, struct link_entry_t *l_entry);
void link_global_fill(struct link_global_t *global, struct link_level_t *level,
		      struct link_entry_t *g_entry, struct link_entry_t *l_entry);
void link_global_copy(struct link_global_t *global, struct link_level_t *dest, struct link_level_t *global_level);
void link_global_delete(struct link_global_t *global);
void link_global_free(struct link_global_t *global);

#endif
