/*

empty c file to define tokens

#token void TOK_NONE =
#token void TOK_LIST_END = 
#token void TOK_STREAM_END = 
#token void TOK_END_OF_FILE = /<<EOF>>/ {}
#token char *TOK_STRING = & {WRITE("\"%s\"", $$);}
#token char *TOK_ISTRING = & {WRITE("<%s>", $$);}
#token char *TOK_NAME = & {WRITE("%s", $$);}
#token char *TOK_VARARG = /[a-zA-Z0-9_]+[ \\t]*\\.\\.\\./
  {for (num = 0; ((('0'<=yytext[num]) && (yytext[num]<='9'))||
                  (('a'<=yytext[num]) && (yytext[num]<='z'))||
                  (('A'<=yytext[num]) && (yytext[num]<='Z'))||
                  (yytext[num] == '_')); num++);
   yytext[num] = 0;
   $$ = string_new(yytext);}
 &{WRITE("%s...", $$);}
#token void TOK_NEWLINE = /(;[^\\n]*)?[ \\t]*\\r?\\n/ {} & {WRITE("\n");}
#token void TOK_ESCAPED_NEWLINE = /\\\\\\r?\\n/ {} & {WRITE("\n");}
#token void TOK_SPACE = /[ \\t]+/ {} & {WRITE(" ");}
#token char TOK_SPECIAL = & {WRITE("%c", $$);}
#token int TOK_INTEGER = /"%"[01]+/            {$$ = strtol(yytext+1, NULL, 2);}
                       | /0[bB][01]+/          {$$ = strtol(yytext+2, NULL, 2);}
                       | /[01]+[bB]/           {$$ = strtol(yytext, NULL, 2);}
                       | /"0"[0-7]+/           {$$ = strtol(yytext+1, NULL, 8);}
                       | /0[oO][0-7]+/         {$$ = strtol(yytext+2, NULL, 8);}
                       | /[0-7]+[oO]/          {$$ = strtol(yytext, NULL, 8);}
                       | /[0-9]+/              {$$ = strtol(yytext, NULL, 10);}
                       | /0[dD][0-7]+/         {$$ = strtol(yytext+2, NULL, 10);}
                       | /[0-7]+[dD]/          {$$ = strtol(yytext, NULL, 10);}
                       | /"$"[0-9a-fA-F]+/     {$$ = strtol(yytext+1, NULL, 16);}
                       | /0[xXhH][0-9a-fA-F]+/ {$$ = strtol(yytext+2, NULL, 16);}
                       | /[0-9a-fA-F]+[hH]/  {$$ = strtol(yytext, NULL, 16);}
                       & {WRITE("%i", $$);}

*/
